%define releasebase 2
%define nbase ganglia

#Use as deafults if no command line inputs
%define as_limulus 1
%{?_with_basement: %{expand: %%define as_basement 1}}
%{?_with_limulus: %{expand: %%define as_limulus 1}}
#pick the target
%if "1" == "%{as_basement}"
%define targetbase Basement
%else
%if "1" == "%{as_limulus}"
%define targetbase Limulus
%endif
%endif
#
# $Id: ganglia.spec.in,v 1.37 2006/03/27 22:52:30 bernardli Exp $
#
# ganglia.spec.  Generated from ganglia.spec.in by configure.
#
# IMPORTANT NOTE:
# This spec file has a noarch section.  RPM is braindead in that it cannot
# build mixed architecture packages.  As a workaround, you must build
# the RPMs using the following commandline
#
# % rpmbuild -ta --target noarch,i386 ganglia-3.0.3.tar.gz
#
# Basement
# Use this:
# rpmbuild -bb --target=noarch ganglia.spec
# rpmbuild -bb ganglia.spec
#
Summary: Ganglia Distributed Monitoring System
Name: ganglia
Version: 3.1.7
URL: http://ganglia.info/
Group: %{targetbase}/Admin
Release: %{releasebase}.%{targetbase}
License: BSD
Vendor: Ganglia Development Team <ganglia-developers@lists.sourceforge.net>
Source: %{name}-%{version}.tar.gz
Buildroot: /var/tmp/%{name}-%{version}-buildroot
Prefix: /usr
BuildRequires: libconfuse, rrdtool-devel, ruby, apr-devel
%description
Ganglia is a scalable, real-time monitoring and execution environment

######################################################################
################## noarch section ####################################
######################################################################
%ifarch noarch
%package web
Summary: Ganglia Web Frontend
Group: System Environment/Base
Obsoletes: ganglia-webfrontend
Provides: ganglia-webfrontend
# We should put rrdtool as a Requires too but rrdtool rpm support is very weak
# so most people install from source
Requires: ganglia-gmetad php-gd 
%define web_prefixdir /var/www/html/ganglia
Prefix: %{web_prefixdir}

%description web
This package provides a web frontend to display the XML tree published by
ganglia, and to provide historical graphs of collected metrics. This website is
written in the PHP4 language.

#######################################################################
#######################################################################
%else

%package gmetad
Summary: Ganglia Meta daemon http://ganglia.sourceforge.net/
Group: System Environment/Base
Obsoletes: ganglia-monitor-core-gmetad ganglia-monitor-core

%description gmetad
Ganglia is a scalable, real-time monitoring and execution environment
with all execution requests and statistics expressed in an open
well-defined XML format.

This gmetad daemon aggregates monitoring data from several clusters
to form a monitoring grid. It also keeps metric history using rrdtool.

%package gmond
Summary: Ganglia Monitor daemon http://ganglia.sourceforge.net/
Group: System Environment/Base
Obsoletes: ganglia-monitor-core-gmond ganglia-monitor-core

%description gmond
Ganglia is a scalable, real-time monitoring and execution environment
with all execution requests and statistics expressed in an open
well-defined XML format.

This gmond daemon provides the ganglia service within a single cluster or
Multicast domain.

%package devel
Summary: Ganglia Library http://ganglia.sourceforge.net/
Group: System Environment/Base
Obsoletes: ganglia-monitor-core-lib 

%description devel
The Ganglia Monitoring Core library provides a set of functions that programmers
can use to build scalable cluster or grid applications

%endif

##
## PREP
##

%prep 
%setup

##
## BUILD
##
%build
GANGLIA_ACK_SYSCONFDIR=1 ./configure --prefix=/usr --with-gmetad  --with-libpcre=no --sysconfdir=/etc/ganglia 
make

##
## PRE
##
%pre

%ifnarch noarch
##
## POST GMETA
##
%post gmetad
/sbin/chkconfig --add gmetad

if [ "$1" == "1" ]; then
   # Installing new package - start gmetad
   /etc/rc.d/init.d/gmetad start
elif [ "$1" -gt "1" ]; then
   # Upgrading ganglia package - restart gmetad
   /etc/rc.d/init.d/gmetad restart
fi
NAME=`hostname`

/bin/cp /etc/gmetad.conf /etc/gmetad.conf.default

sed -e "s!data_source \"my cluster\" localhost!data_source \"$NAME Cluster\" localhost!g" /etc/gmetad.conf.default > /etc/gmetad.conf


##
## POST GMON
##
# basement - gmond is not started automatically because 
# when it is installed in the vnfs it does not need to be started
# we do not check for old config as well becuase
# it does not play well with vnfs
# also we use /opt/ganglia to store the cluster wide gmond, so
# changes can be made easily. 
# the hostname is also inserted in the gmond.conf and gmetad.conf
%post gmond
/sbin/chkconfig --add gmond
echo "You must start gmond by hand on the master node by running:"
echo ""
echo "  service gmond start"
echo ""
echo "If you are installing in the VNFS, gmond will start automatically"
echo "when you boot the nodes. It will automatically start on the"
echo "master node when it is rebooted."

NAME=`hostname`

/bin/cp /opt/ganglia/gmond.conf /opt/ganglia/gmond.conf.default

sed -e "s!name = \"unspecified\"!name = \"$NAME Cluster\"!g" /opt/ganglia/gmond.conf.default >/opt/ganglia/gmond.conf

/bin/cp /etc/rc.d/init.d/gmond /etc/rc.d/init.d/gmond.default

sed -e 's!daemon $GMOND!daemon $GMOND --conf=/opt/ganglia/gmond.conf!g'  /etc/rc.d/init.d/gmond.default > /etc/rc.d/init.d/gmond

rm /etc/rc.d/init.d/gmond.default

if [ -e /etc/perceus/perceus.conf ]
then
  ETH=`grep "master network device = " /etc/perceus/perceus.conf|awk '{print $5}'`
  if grep 'route add -host 239.2.11.71 dev $ETH' /etc/rc.d/rc.local >/dev/null
  then
    echo "gmond startup already in /etc/rc.d/rc.local"
  else
    echo "Adding multicast route for $ETH to rc.local for gmond"
    cat <<EOF >>  /etc/rc.d/rc.local
# Added by Ganglia install. Do not remove
route add -host 239.2.11.71 dev $ETH
service gmond restart
service gmetad restart
EOF
 fi
fi
##
## PREUN GMETA
##
%preun gmetad
if [ "$1" = 0 ]
then
   /etc/rc.d/init.d/gmetad stop
   /sbin/chkconfig --del gmetad
fi

##
## PREUN GMON
##
%preun gmond
if [ "$1" = 0 ]
then
   /etc/rc.d/init.d/gmond stop
   /sbin/chkconfig --del gmond
fi
echo "Removing sge_execd startup from rc.local (if it exists)"
grep -v 'Added by Ganglia install. Do not remove' /etc/rc.d/rc.local >/tmp/rc.local
grep -v 'route add -host 239.2.11.71 dev' /tmp/rc.local >/tmp/rc.local1
grep -v 'service gmond restart' /tmp/rc.local1 >/tmp/rc.local
grep -v 'service gmetad restart' /tmp/rc.local >/tmp/rc.local1
cat /tmp/rc.local1 >/etc/rc.d/rc.local
rm -f /tmp/rc.local*

#ifnarch noarch
%endif

##
## INSTALL
##
%install
## Flush any old RPM build root
%__rm -rf $RPM_BUILD_ROOT

%ifarch noarch
pushd web
make conf.php
make version.php
popd
%__mkdir -p $RPM_BUILD_ROOT/%{web_prefixdir}
%__cp -rf %{_builddir}/%{name}-%{version}/web/* $RPM_BUILD_ROOT/%{web_prefixdir}

%else

## Create the directory structure
%__mkdir -p $RPM_BUILD_ROOT/etc/rc.d/init.d
%__mkdir -p $RPM_BUILD_ROOT/var/lib/ganglia/rrds
%__mkdir -p $RPM_BUILD_ROOT/usr/share/man/man5
%__mkdir -p $RPM_BUILD_ROOT/opt/ganglia

## Move the files into the structure
if [ -f /etc/SuSE-release ]; then
   %__cp -f %{_builddir}/%{name}-%{version}/gmond/gmond.init.SuSE $RPM_BUILD_ROOT/etc/rc.d/init.d/gmond
   %__cp -f %{_builddir}/%{name}-%{version}/gmetad/gmetad.init.SuSE $RPM_BUILD_ROOT/etc/rc.d/init.d/gmetad
   chmod +x $RPM_BUILD_ROOT/etc/rc.d/init.d/gmond
   chmod +x $RPM_BUILD_ROOT/etc/rc.d/init.d/gmetad
else
   %__cp -f %{_builddir}/%{name}-%{version}/gmond/gmond.init $RPM_BUILD_ROOT/etc/rc.d/init.d/gmond
   %__cp -f %{_builddir}/%{name}-%{version}/gmetad/gmetad.init $RPM_BUILD_ROOT/etc/rc.d/init.d/gmetad
fi
/bin/mkdir -p $RPM_BUILD_ROOT/etc/ganglia/
# We just output the default gmond.conf from gmond using the '-t' flag
%{_builddir}/%{name}-%{version}/gmond/gmond -t > $RPM_BUILD_ROOT/etc/ganglia/gmond.conf
%{_builddir}/%{name}-%{version}/gmond/gmond -t > $RPM_BUILD_ROOT/opt/ganglia/gmond.conf
cd gmetad
make gmetad.conf
cd ..
%__cp -f %{_builddir}/%{name}-%{version}/gmetad/gmetad.conf $RPM_BUILD_ROOT/etc/ganglia/gmetad.conf

# put the $RPM_BUILD_ROOT into Makefile so install works
fix=`find . -name Makefile -print`

for i in $fix
do
cp $i $i.1
sed -e "s!libdir = /usr/lib64!libdir = $RPM_BUILD_ROOT/usr/lib64!g" $i.1 > $i.2
sed -e "s!prefix = /usr!prefix = $RPM_BUILD_ROOT/usr!g" $i.2 > $i.3
sed -e "s!moduledir = /usr/lib64/ganglia!moduledir = $RPM_BUILD_ROOT/usr/lib64/ganglia!g" $i.3 > $i.4
sed -e "s!sysconfdir = /etc/ganglia!sysconfdir = $RPM_BUILD_ROOT/etc/ganglia!g" $i.4 > $i
done

%__make install 
%__cp -f %{_builddir}/%{name}-%{version}/gmond/gmond.conf.5 $RPM_BUILD_ROOT/usr/share/man/man5/gmond.conf.5
%endif

%ifnarch noarch
##
## FILES GMETA
##

%files gmetad
%defattr(-,root,root)
%attr(0755,nobody,nobody)/var/lib/ganglia/rrds
/usr/sbin/gmetad
/etc/rc.d/init.d/gmetad
%config(noreplace) /etc/ganglia/gmetad.conf

##
## FILES GMON
##
%files gmond
%defattr(-,root,root)
%attr(0500,root,root)/usr/bin/gmetric
%attr(0555,root,root)/usr/bin/gstat
/usr/sbin/gmond
/etc/rc.d/init.d/gmond
%attr(0555,root,root)/usr/share/man/man5/gmond.conf.5*
%config(noreplace) /etc/ganglia/gmond.conf
%config(noreplace) /opt/ganglia/gmond.conf

##
## FILES DEVEL
##
%files devel
/usr/include/*.h
/usr/lib*/ganglia/*
/usr/lib*/libganglia*
/usr/bin/ganglia-config
/etc/ganglia/conf.d/modpython.conf
%else

##
## FILES WEB
##
%files web
%defattr(-,root,root)
%config(noreplace) %{web_prefixdir}/conf.php
%{web_prefixdir}

%endif

##
## CLEAN
##
%clean
%__rm -rf $RPM_BUILD_ROOT

##
## CHANGELOG
##
%changelog
* Thu Dec 23 2010 Doug Eadline <deadline@eadline.org>
- updated for new version 3.1.7
- configure for /opt/ganlia for gmond.conf
- fix Makefiles to work with install 
- added Limulus, Basement, tags
* Fri Dec 10 2004 Matt Massie <massie@cs.berkeley.edu>
- Updated the spec file for 2.6.0 release
* Tue Apr 13 2004 Brooks Davis <brooks@one-eyed-alien.net>
- Use the autoconf variable varstatedir instead of /var/lib for consistancy.
* Thu Feb 19 2004 Matt Massie <massie@cs.berkeley.edu>
- Removed the /usr/include/ganglia directory from the lib rpm and
  changed the deprecated Copyright to License
* Mon Oct 14 2002 Federico Sacerdoti <fds@sdsc.edu>
- Split package into -gmetad and -gmond subpackages for clarity,
  and separation of purpose/functionality.
* Thu Sep 19 2002 Federico Sacerdoti <fds@sdsc.edu>
- Added config files, made /var/lib/ganglia for RRD storage.
* Mon Mar 11 2002 Matt Massie <massie@cs.berkeley.edu>
- Added support for libganglia, added Prefix: for RPM relocation
* Wed Feb 27 2002 Matt Massie <massie@cs.berkeley.edu>
- Merge gmetric and gmond together into one RPM.  Fix some small bugs.
* Fri Nov  2 2001 Matt Massie <massie@cs.berkeley.edu>
- initial release
